use dep::std;
use dep::helpers;
use dep::helpers::hash;
use dep::helpers::structs;

global tx_vkHash: Field = 0x2e592c2ade5527a4aaa1a68b75bdff97876a8bc89c8d41a704f1e2b23a82b698;

#[recursive]
fn main(
  public_inputs_hash: pub Field, 
  transaction_verifier: structs::VerifierTx
) {
    assert(transaction_verifier.key_hash == tx_vkHash);
    std::verify_proof(
        transaction_verifier.verification_key.as_slice(), 
        transaction_verifier.proof.as_slice(), 
        [public_inputs_hash].as_slice(), 
        transaction_verifier.key_hash 
    );
}