import { ConnectHero } from "./components/connect-hero";
import { Navbar } from "./components/navbar";
import { useState } from "react";
import { Button } from "./components/buttons";
function App() {

  const [connected, setConnection] = useState("disconnected");
  return (
    <div className="bg-back h-dvh text-white">
      <div className="md:hidden z-20 fixed min-h-screen w-full bg-back text-center">
        <h1 className="absolute text-2xl top-[30%] inset-x-2">Sorry, the Offshift app is not currently available on mobile!</h1>
        <p className="text-xl inset-x-2 absolute top-[40%]">
          Due to performance requirements, mobile devices are not supported. 
          This feature is under development and will be implemented soon.
        </p>
        <div className="absolute top-[60%] inset-x-2 mx-6">
          <Button text={"Go to main website "} hook={() => window.location.href = "https://offshift.io/"}></Button>
        </div>
      </div>
      <Navbar
        route={"connecting"}
        connected={connected}
        setConnection={setConnection}
      ></Navbar>
      <ConnectHero
        connected={connected}
        setConnection={setConnection}
      ></ConnectHero>
    </div>
  );
}

export default App;
