import { Player } from '@lottiefiles/react-lottie-player';
import { useState, useEffect } from 'react';
import { useNavigate } from 'react-router-dom';
import { connectWallet } from '../utils/connect-wallet';
import lottieData from "../assets/lottie-animations.json";

export const ConnectHero = (props: any) => {

    const [buttonText, setButtonText] = useState("Connect\nWallet");
    const navigate = useNavigate();

    const handleClick = async () => {
        setButtonText("Connecting...");
        props.setConnection("connecting");
        await connectWallet(props.setConnection);
    };
    useEffect(() => {
        if (props.connected == "connecting") {
            setButtonText("Connecting...");
        } else if (props.connected == "connected") {
            navigate('/shift');
        }
        else {
            setButtonText("Connect wallet");
        }
    })
    const buttonClass = props.connected == "connecting" ? "bg-disabled-button" : "bg-purple hover:bg-button-default ";

    return (
        <>
            <div className="flex h-dvh items-center justify-center">
                <button className={`font-sans font-medium w-32 h-32 rounded-full z-10 mt-24 ${buttonClass}`}
                    onClick={handleClick}
                >
                    <h1 className='whitespace-pre'>{buttonText}</h1>
                </button>
                <div className="flex items-center justify-center absolute animate-pulse inset-0 pt-24">
                    {props.connected == "connecting" ? (
                        <Player
                            autoplay
                            loop
                            src={lottieData}
                            className="w-72 h-72 z-0"
                        >
                        </Player>
                    ) : (
                        <img
                            src='/img_0.png'
                            className="w-60 h-60 z-0 mt-0"></img>
                    )}
                </div>
            </div>
        </>
    );
}