import logo from "../assets/logo.png";
import { useState } from "react";
import { Link } from "react-router-dom";
import { Account } from "./account";
import { connectWallet } from "../utils/connect-wallet";
import { useSelector } from "react-redux";
import AccountIcon from "./account-icon";

export const Navbar = (props: any) => {
    const [isAccountOpen, setIsAccountOpen] = useState(false);

    const toggleAccount = () => {
        setIsAccountOpen(!isAccountOpen);
    };

    const balances = useSelector((state: any) => { return { "address": state.address, "oldXFT": state.oldXFT } });

    const handleClick = async () => {
        props.setConnection("connecting");
        await connectWallet(props.setConnection);
    };

    if (props.route != "connecting") {
        return (
            <header className="pt-4 flex flex-row">
                <Link to="/">
                    <img className="fixed w-40 pl-2" src={logo} alt="" />
                </Link>
                <button
                    className="group fixed transition-all duration-700 ease-out w-10 md:hover:w-40 overflow-hidden sm:hover:bg-purple-transparent p-2 rounded-full md:rounded-3xl top-2 right-2 z-10"
                    onClick={toggleAccount}
                >
                    <h1 className="flex row-auto gap-3 text-center"><AccountIcon address={balances.address} size={30}></AccountIcon>
                        <span className="my-auto text-light-font font-semibold transition-all duration-500 ease-out translate-x-40 md:group-hover:translate-x-0 text-sm">{balances.address.slice(0, 6)}....{balances.address.slice(-4)}</span>
                    </h1>

                </button>
                <Account
                    isVisible={isAccountOpen}
                    setVisible={setIsAccountOpen}
                ></Account>
                <nav className="fixed bottom-0 w-full bg-widget-background border-t border-border md:top-1 md:left-48 md:border-0 md:h-fit md:w-1/4 md:bg-transparent z-20">
                    <div className="flex items-center h-16 text-xl md:text-2xl">
                        <ul className="flex w-full md:space-x-10">
                        {balances.oldXFT != 0 ? (
                            <>
                            <Link
                                to="/Shift"
                                className="transition-all hover:scale-110 duration-500 ease-in-out text-white flex-grow text-center rounded-lg hover:bg-dark-transparent border-2 border-border border-opacity-0 hover:border-opacity-100"
                            >
                                <li>Shift</li>
                            </Link>
                            <Link
                                to="/Upgrade"
                                className="transition-all hover:scale-110 duration-500 text-white flex-grow text-center rounded-lg hover:bg-dark-transparent border-2 border-border border-opacity-0 hover:border-opacity-100"
                            >
                                <li>Upgrade</li>
                            </Link>
                            </>
                        ) : null}
                            {/* <Link
                                to="/Stake"
                                className="transition-all hover:scale-110 duration-500 text-white flex-grow text-center rounded-lg hover:bg-dark-transparent border-2 border-border border-opacity-0 hover:border-opacity-100"
                            >
                                <li>Stake</li>
                            </Link>
                            <Link
                                to="/compliance"
                                className="transition-all hover:scale-110 duration-500 text-white flex-grow text-center rounded-lg hover:bg-dark-transparent border-2 border-border border-opacity-0 hover:border-opacity-100"
                            >
                                <li>Compliance</li>
                            </Link> */}
                        </ul>
                    </div>
                </nav>
            </header>
        );
    }

    return (
        <header className="pt-4 absolute flex flex-row">
            <Link to="/">
                <img className="fixed w-40 pl-2" src={logo} alt="" />
            </Link>
            {props.connected == "disconnected" ? (
                <>
                    <button
                        className="fixed bg-purple hover:bg-button-default  p-2 rounded-lg right-2 z-10"
                        onClick={handleClick}
                    >
                        <h1>Connect wallet</h1>
                    </button>
                </>
            ) : (
                <>
                    <button className="fixed bg-disabled-button p-2 rounded-lg right-2 z-10">
                        <h1>Connecting</h1>
                    </button>
                    <nav className="fixed bottom-0 w-full bg-widget-background border-t border-border md:top-1 md:left-48 md:border-0 md:h-fit md:w-1/4 md:bg-transparent z-20">
                        <div className="flex items-center h-16 text-xl md:text-2xl">
                        </div>
                    </nav>
                </>
            )}
        </header>
    );
};
