import { useSelector } from "react-redux";

export const Selector = (props: any) => {
  const balances = useSelector((state: any) => state[props.data[0]]);
  const addNum = (e: any) => {
    props.setAmount(e.target.value);
  };
  let max = balances - Number(props.fees);
  max = max < 0 ? 0 : max;
  max = props.data[0] == "" ? null : max;
  return (
    <>
      <div className="flex flex-row !bg-back h-[12vh] md:h-36 align-items-center justify-evenly rounded-lg md:rounded-2xl relative">
        {props.disabled ? (
          <input
            type="number"
            disabled
            className="absolute outline-none w-[50%] bg-transparent text-sm md:text-2xl left-4 top-[40%]"
            placeholder={props.amount === "" ? "0" : ""}
            onChange={addNum}
            value={props.amount}
          />
        ) : (
          <input
            type="number"
            className="absolute outline-none w-[50%] !bg-transparent text-sm md:text-2xl left-4 top-[40%]"
            placeholder={props.amount === "" ? "0" : ""}
            onChange={addNum}
            value={props.amount}
          />
        )}

        <div className="absolute flex flex-col justify-center sm:gap-5 w-fit right-4 top-3 md:top-6">
          <div
            className={`${
              props.noSelect
                ? "cursor-default"
                : "cursor-pointer hover:opacity-60"
            } flex flex-row gap-1 md:gap-3 place-items-center w-fit bg-dark-transparent rounded-3xl py-1 px-1 md:py-2 translate-opacity duration-150`}
            onClick={() => {
              props.setSelect([props.data[0], props.data[1], ""]);
            }}
          >
            {props.data[1] != null ? (
              <img className="w-6 md:w-10" src={props.data[1]} alt="" />
            ) : (
              <></>
            )}

            <h1 className="text-md md:text-xl pl-2 md:ml-2 sm:pl-0">
              {props.data[1] != null ? props.data[0] : "Select Token"}{" "}
              {props.noSelect ? (
                <span className="mx-1 md:mx-4"></span>
              ) : (
                <span className="mx-1 md:mx-4">⌵</span>
              )}
            </h1>
          </div>
        </div>
        <h1
          className="absolute hover:text-light-font cursor-pointer right-5 bottom-2 text-[0.7rem] md:text-xl md:bottom-1"
          onClick={() => props.setAmount(max)}
        >
          {max} {props.data[0]}{" "}
        </h1>
      </div>
    </>
  );
};

export const DisabledSelector = (props: any) => {
  const balances = useSelector((state: any) => state);
  const addNum = (e: any) => {
    props.setAmount(e.target.value);
  };
  return (
    <>
      <div className="flex flex-row bg-back h-[12vh] md:h-36 align-items-center justify-evenly rounded-lg md:rounded-2xl relative">
        <input
          type="number"
          className="absolute outline-none w-[50%] bg-transparent text-sm md:text-2xl left-4 top-[40%]"
          placeholder="0"
          onChange={addNum}
          value={props.amount}
        />
        <div className="absolute flex flex-col justify-center sm:gap-5 w-fit right-4 top-3 md:top-6">
          <div className="flex flex-row gap-3 md:gap-3 place-items-center w-fit bg-[#0c0c0ca3] rounded-3xl py-1 px-1 md:py-2">
            <img className="w-6 md:w-10" src={props.data[1]} alt="" />
            <h1 className="text-md md:text-xl">
              {props.data[0]} <span className="mx-1 md:mx-4"></span>
            </h1>
          </div>
        </div>
        <h1 className="absolute cursor-default right-6 bottom-1 text-[0.7rem] md:text-xl">
          {balances[props.data[0]]} {props.data[0]}{" "}
        </h1>
      </div>
    </>
  );
};
