export const SwapButton = (props: any) => {


    return (
        <div
            data-testid="swap-currency-button"
            color="#FFFFFF"
            className="text-center scale-[80%] mb-2 sm:mb-1 sm:scale-100 rounded-md p-1 border-2 border-widget-background bg-back hover:bg-modal"
            onClick={props.switchSelects}
            role="button"
            onKeyDown={(e) => {
                if (e.key === "Enter" || e.key === " ") {
                    props.switchSelects();
                }
            }}
        >
            <svg
                xmlns="http://www.w3.org/2000/svg"
                width="16"
                height="16"
                viewBox="0 0 24 24"
                fill="none"
                stroke="#FFFFFF"
                strokeWidth="2"
                strokeLinecap="round"
                strokeLinejoin="round"
                className={`${props.expert ? "transform -rotate-90 -px-2 z-50" : ""}`}
            >
                <line x1="12" y1="5" x2="12" y2="19"></line>
                <polyline points="19 12 12 19 5 12"></polyline>
            </svg>
        </div>
    );
}

export default SwapButton;
