export const Toggle = (props: any) => {
    return (
        <div>

            <label htmlFor="toggle" className="flex items-center cursor-pointer">
                <input
                    id="toggle"
                    type="checkbox"
                    className="hidden"
                    onClick={() => {
                        props.setAuto(!props.automatic);
                    }}
                />
                {props.automatic ? (
                    <>
                        <h1 className="text-xl pr-4">{props.name1 || "Auto"}</h1>
                        <div className="w-11 h-6 bg-purple rounded-full pt-0.5 transition-colors duration-700">
                            <div className="ml-1 w-5 h-5 bg-white rounded-full shadow-md transition duration-300 ease-in-out"></div>
                        </div>
                    </>
                ) : (
                    <>
                        <h1 className="text-xl pr-1">{props.name2 || "Manual"}</h1>
                        <div className="relative w-11 h-6 rounded-full pt-0.5 transition-colors bg-modal-bg duration-700">
                            <div className="w-5 h-5 bg-white rounded-full shadow-md transition duration-300 ease-in-out translate-x-full"></div>
                        </div>
                    </>
                )}
            </label>
        </div>
    );
};


export const ExpertToggle = (props: any) => {
    return (
        <div className="flex flex-col">

            <label htmlFor="toggle" className="flex items-center cursor-pointer">
                <input
                    id="toggle"
                    type="checkbox"
                    className="hidden"
                    onClick={() => {
                        props.setExpert(!props.expert);
                    }}
                />

                <div className="flex flex-col w-[80%] pl-2">
                    <h1 className="text-left">{props.name || "Expert Mode"}</h1>
                    <p className="text-left text-sm text-[#ffd900c8]">Caution: Expert mode is intended for technical users and should be used at your own risk.</p>
                </div>
                {props.expert ? (
                    <div className="relative w-11 h-6 rounded-full pt-0.5 ml-2 transition-colors bg-purple duration-700">
                        <div className="w-5 h-5 bg-[#ff8bff] rounded-full shadow-md transition duration-300 ease-in-out translate-x-full"></div>
                    </div>
                ) : (
                    <div className="w-11 h-6 bg-[#4b4b4b] rounded-full pt-0.5 ml-2 transition-colors duration-700">
                        <div className="ml-1 w-5 h-5 bg-grey rounded-full shadow-md transition duration-300 ease-in-out"></div>
                    </div>
                )}
            </label>
        </div>
    );
};