import { useSelector } from "react-redux";;
import { AddUTXO, RemoveUTXO, SubmitUTXO } from "./buttons";
import lock from "../assets/lock-svg.svg";

export const UTXODragnDrop = (props: any) => {
    return (
        <button className="group relative flex flex-col shrink-0 justify-between h-14 items-center transition-all duration-500 ease-in-out mx-auto px-8 bg-purple-transparent rounded-2xl w-40 pl-2 py-2 hover:bg-modal overflow-visible" onClick={() => console.log(props.name)}>
            <div className="absolute ml-auto -right-2 top-0">
                <RemoveUTXO hook={() => { props.remove([props.idx]) }} />
            </div>
            <div className="flex items-center justify-around w-full my-auto">
                <div className="relative w-10">
                    {props.name.slice(0, 2) == "zk" ? <img src={lock} className="absolute w-4 -top-2 left-2" alt="" /> : <></>}
                    <img className={`absolute -left-1 -top-5 w-10 transition-all duration-500 ease-in-out ${props.name.toLowerCase() == "xft" || props.name.toLowerCase() == "zkxft" ? "group-hover:rotate-180" : ""}`} src={props.image} alt="" />
                </div>
                <p className=" transition-all duration-500 ease-in-out font-bold">{props.amount}</p>
            </div>

        </button>
    )
}

export const UTXOCreate = (props: any) => {

    const addNum = (e: any) => {
        props.setAmount(e.target.value);
    }

    const toggleSelect = (r) => {
        props.setSelect(r)
    }

    const hasRecipient = () => {
        return (props.data[0].slice(0, 2) != "zk" && props.data[0] != "" && props.out)
    }

    return (
        <>
            <button className={`${props.data[0].slice(0, 2) != "zk" && props.data[0] != "" && props.out ? "h-32" : "h-24"} group relative flex flex-col shrink-0 w-[95%] justify-between place-items-center mx-auto px-8 bg-purple-transparent rounded-2xl pl-2 py-2 overflow-visible`}>
                <div className="relative ml-auto left-10 bottom-1">
                    <SubmitUTXO hook={() => {
                        props.update()
                    }}></SubmitUTXO>
                </div>
                {
                    props.data[0].slice(0, 2) == "zk" && !props.out ?
                        <></>
                        :
                        <input type="number" className={`${hasRecipient() ? "top-[30%] pl-2" : "top-[40%]"} absolute outline-none w-[50%] !bg-transparent text-lg left-4`} placeholder="0" onChange={addNum} value={props.amount} />
                }
                {
                    hasRecipient() ?
                        <input name="recipient" type={"text"} autoComplete="off" className="absolute outline-none w-[84%] h-8 bg-back rounded-lg pl-4 left-4 text-lg bottom-2" placeholder="Recipient Address" onChange={(r) => props.setRecipient(r.target.value)} />
                        :
                        <></>
                }
                <div className="absolute flex flex-col justify-center sm:gap-5 w-fit right-2 top-3 md:top-8">
                    <div className={`${props.noSelect ? "cursor-default" : "cursor-pointer hover:opacity-60"} flex flex-row gap-1 place-items-center w-fit bg-dark-transparent rounded-3xl py-1 px-1 md:py-2 translate-opacity duration-150`} onClick={() => { props.setSelect([props.data[0], props.data[1], ""]) }}>
                        {props.data[1] != null ? <img className="w-6" src={props.data[1]} alt="" /> : <></>}

                        <h1 className="text-md ml-2">{props.data[1] != null ? props.data[0] : "Select Token"} <span className="mx-1">⌵</span></h1>
                    </div>
                </div>
            </button>
        </>
    )
}