import { createSlice, PayloadAction } from '@reduxjs/toolkit'
import type { Balance } from '../utils/helpers';


// Define the initial state using that type
const initialState: Balance = {
    address: "0x0",
    ETH: "0",
    oldXFT: "0",
    XFT: "0",
    anonUSD: "0",
    anonBTC: "0",
    zkXFT: "0"
}


export const balancesReducer = createSlice({
    name: 'balances',
    // `createSlice` will infer the state type from the `initialState` argument
    initialState,
    reducers: {
        set: (state, action: PayloadAction<Balance>) => {
            Object.assign(state, action.payload);
        },
    }

})

export const { set } = balancesReducer.actions

// Other code such as selectors can use the imported `RootState` type
// export const selectBalance = (state: any) => state.balances

export default balancesReducer.reducer