import { createSlice, PayloadAction } from '@reduxjs/toolkit'
import type { PriceFeed } from '../utils/helpers';
import { getTotal } from '../utils/helpers';

// Define the initial state using that type
const initialState: PriceFeed = await getTotal()

export const feedReducer = createSlice({
    name: 'feed',
    // `createSlice` will infer the state type from the `initialState` argument
    initialState,
    reducers: {
        set: (state, action: PayloadAction<PriceFeed>) => {
            Object.assign(state, action.payload);
        },
    }

})

export const { set } = feedReducer.actions

// Other code such as selectors can use the imported `RootState` type
// export const selectBalance = (state: any) => state.balances

export default feedReducer.reducer