import React, { ReactNode } from "react";
import ReactDOM from "react-dom/client";
import { createBrowserRouter, RouterProvider } from "react-router-dom";
import App from "./App.tsx";
import { Shift } from "./routes/shift.tsx";
import ErrorPage from "./error-page.tsx";
import "./index.css";
import { Upgrade } from "./routes/upgrade.tsx";
import { Stake } from "./routes/stake.tsx";
import { store } from "./store";
import { Provider } from "react-redux";
import { Compliance } from "./routes/compliance.tsx";

const router = createBrowserRouter([
  {
    path: "/",
    element: (
      <Provider store={store}>
        <App />
      </Provider>
    ),
    errorElement: <ErrorPage />,
  },
  {
    path: "/shift",
    element: (
      <Provider store={store}>
        <Shift />
      </Provider>
    ),
  },
  {
    path: "/upgrade",
    element: (
      <Provider store={store}>
        <Upgrade />
      </Provider>
    ),
  },
  // {
  //   path: "/stake",
  //   element: (
  //     <Provider store={store}>
  //       <Stake />
  //     </Provider>
  //   ),
  // },
  // {
  //   path: "/compliance",
  //   element: (
  //     <Provider store={store}>
  //       <Compliance/>
  //     </Provider>
  //   ),
  // }
]);

ReactDOM.createRoot(document.getElementById("root") as HTMLElement).render(
  <React.StrictMode>
    <RouterProvider router={router} />
  </React.StrictMode>
);
