/** @type {import('tailwindcss').Config} */
export default {
  content: [
    "./index.html",
    "./src/**/*.{js,ts,jsx,tsx,svg}",
  ],
  theme: {
    colors: {
      "back": "#140736",
      "back-transparent": "#140736B2",
      "white": "#ffffff",
      "light-font": "#e4adee",
      "purple": "#6b39fa",
      "purple-transparent": "#6b39fa40",
      "button-default": "#702caa",
      "disabled-button": "#2b123f",
      "disabled-button-text": "#570d97",
      "grey": "#AEA4A4",
      "widget-background": "#3c0867",
      "border": "#b167bf",
      "hover": "#561A89",
      "opaque": "#ffffff69",
      "dark-transparent": "#00000090",
      "modal-bg": "#00000036",
      "modal": "#570d97",
      "select": "#0c0c0ca3",
      "select-100": "#381f7a",
      "swap-button": "#220e57",
      "transparent": "transparent",
      "mini-widget": "#1b0b44"
    },
    extend: {
      fontFamily: {
        'roboto': ["Roboto", 'sans-serif'],
      },
      backgroundSize: {
        'size-200': '200% 200%',
      },
      backgroundPosition: {
        'pos-0': '0% 0%',
        'pos-100': '100% 100%',
      },
      animation: {
        'spin-bezier': 'spin 1s cubic-bezier(.03,.59,.94,.5) infinite',
      },
    },
  },
  plugins: [],
}

