# momiji-node-ts

This is the node for publishing batch transactions to the momiji protocol


## FAQ
- Global Config: One config, initialized in index.ts and borrowed from the .env
- npm warnings are ok, npm outputs a lot of warnings.

## USAGE

First clone this repo.

- Copy over the .env.example file to .env
and Fill out the `.env` file with your hex formatted private key and your RPC URL

and after that there are 2 alternatives for running a node either the quick way with docker or for those who already have a configured development machine setup.

### Docker setup
for building
```sh
sudo docker build -t xftnode .
```

for running
```sh
sudo docker run -p 5150:5150 -it xftnode
```
### npm usage
- Install noirup, the Nargo package manager
```sh
curl -L https://raw.githubusercontent.com/noir-lang/noirup/main/install | bash
```
- Install nargo v0.28.0
```
noirup --version 0.28.0
```

- Install nvm and grab the latest LTS version of node 
```sh
curl -o- https://raw.githubusercontent.com/nvm-sh/nvm/v0.40.0/install.sh | bash
```
Restart your terminal and then run
```sh
nvm install --lts
nvm use --lts
```
```
cd ./momiji-helpers && npm install && cd .. && npm install
```
- Run `npm run start` to start the node
