import { HardhatUserConfig } from "hardhat/config";
import "@nomicfoundation/hardhat-toolbox";
import "@openzeppelin/hardhat-upgrades";

const config: HardhatUserConfig = {
  solidity: {
    version: '0.8.24',
    settings: {
      evmVersion: 'cancun',
      optimizer: { enabled: true, runs: 5000 },
    },
  },
  networks: {
    hardhat: {
      blockGasLimit: 30000000,
      gasPrice: "auto",
      hardfork: 'cancun',
      accounts: {
        mnemonic: "artwork story jeans lyrics expose update sword absurd rail game argue submit"
      },
      chainId: 1
    }
  },
  mocha: {
    timeout: 200000
  }
};

export default config;
