struct Payment {
    bytes32 recipient;
    uint256 withdrawalAmount;
    uint256 swapAmount;
    uint160 price_limit;
}

struct Deposit {
    bytes signature;
    bytes32 pi_hash;
}

struct DepositHash {
    bytes32 pi_hash;
}

struct EncryptedUTXO {
    bytes32 secret;
    bytes32 amount;
    bytes32 data;
}

struct Transaction {
    bytes32 current_root;
    bytes32 utxo_root;
    bytes32 price_limit;
    bytes32 timestamp;
    bytes32 deadline;
    bytes32 amount;
    EncryptedUTXO[16] encrypted_utxo;
    bytes32[16] withdrawals;
    bytes32[16] commitments_in;
    bytes32[16] commitments;
    bytes32[16] recipients;
    bytes32[16] nullifier_hashes;
    bytes32[16] uids;
    bytes32[16] swap_amounts;
    Deposit deposit;
}

struct TransactionWithProof {
    Transaction transaction;
    bytes32[93] proof;
    bytes proofU8;
}

struct Batch {
    bytes32 tx_key_hash;
    bytes32 recursive_key_hash;
    bytes32 new_root;
    bytes32 old_hist_root;
    bytes32 new_hist_root;
    bytes32 oracle;
    bytes32[20] historic_path;
    bytes32[16] aggregation_object;
    Transaction[] transactions;
}