/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BytesLike,
  FunctionFragment,
  Result,
  Interface,
  ContractRunner,
  ContractMethod,
  Listener,
} from "ethers";
import type {
  TypedContractEvent,
  TypedDeferredTopicFilter,
  TypedEventLog,
  TypedListener,
  TypedContractMethod,
} from "../../common";

export type EncryptedUTXOStruct = {
  secret: BytesLike;
  amount: BytesLike;
  data: BytesLike;
};

export type EncryptedUTXOStructOutput = [
  secret: string,
  amount: string,
  data: string
] & { secret: string; amount: string; data: string };

export type DepositStruct = { signature: BytesLike; pi_hash: BytesLike };

export type DepositStructOutput = [signature: string, pi_hash: string] & {
  signature: string;
  pi_hash: string;
};

export type TransactionStruct = {
  current_root: BytesLike;
  utxo_root: BytesLike;
  price_limit: BytesLike;
  timestamp: BytesLike;
  deadline: BytesLike;
  amount: BytesLike;
  encrypted_utxo: EncryptedUTXOStruct[];
  withdrawals: BytesLike[];
  commitments_in: BytesLike[];
  commitments: BytesLike[];
  recipients: BytesLike[];
  nullifier_hashes: BytesLike[];
  uids: BytesLike[];
  swap_amounts: BytesLike[];
  deposit: DepositStruct;
};

export type TransactionStructOutput = [
  current_root: string,
  utxo_root: string,
  price_limit: string,
  timestamp: string,
  deadline: string,
  amount: string,
  encrypted_utxo: EncryptedUTXOStructOutput[],
  withdrawals: string[],
  commitments_in: string[],
  commitments: string[],
  recipients: string[],
  nullifier_hashes: string[],
  uids: string[],
  swap_amounts: string[],
  deposit: DepositStructOutput
] & {
  current_root: string;
  utxo_root: string;
  price_limit: string;
  timestamp: string;
  deadline: string;
  amount: string;
  encrypted_utxo: EncryptedUTXOStructOutput[];
  withdrawals: string[];
  commitments_in: string[];
  commitments: string[];
  recipients: string[];
  nullifier_hashes: string[];
  uids: string[];
  swap_amounts: string[];
  deposit: DepositStructOutput;
};

export type BatchStruct = {
  tx_key_hash: BytesLike;
  recursive_key_hash: BytesLike;
  new_root: BytesLike;
  old_hist_root: BytesLike;
  new_hist_root: BytesLike;
  oracle: BytesLike;
  historic_path: BytesLike[];
  aggregation_object: BytesLike[];
  transactions: TransactionStruct[];
};

export type BatchStructOutput = [
  tx_key_hash: string,
  recursive_key_hash: string,
  new_root: string,
  old_hist_root: string,
  new_hist_root: string,
  oracle: string,
  historic_path: string[],
  aggregation_object: string[],
  transactions: TransactionStructOutput[]
] & {
  tx_key_hash: string;
  recursive_key_hash: string;
  new_root: string;
  old_hist_root: string;
  new_hist_root: string;
  oracle: string;
  historic_path: string[];
  aggregation_object: string[];
  transactions: TransactionStructOutput[];
};

export interface IMomijiInterface extends Interface {
  getFunction(nameOrSignature: "publish"): FunctionFragment;

  encodeFunctionData(
    functionFragment: "publish",
    values: [BytesLike, BatchStruct]
  ): string;

  decodeFunctionResult(functionFragment: "publish", data: BytesLike): Result;
}

export interface IMomiji extends BaseContract {
  connect(runner?: ContractRunner | null): IMomiji;
  waitForDeployment(): Promise<this>;

  interface: IMomijiInterface;

  queryFilter<TCEvent extends TypedContractEvent>(
    event: TCEvent,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEventLog<TCEvent>>>;
  queryFilter<TCEvent extends TypedContractEvent>(
    filter: TypedDeferredTopicFilter<TCEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEventLog<TCEvent>>>;

  on<TCEvent extends TypedContractEvent>(
    event: TCEvent,
    listener: TypedListener<TCEvent>
  ): Promise<this>;
  on<TCEvent extends TypedContractEvent>(
    filter: TypedDeferredTopicFilter<TCEvent>,
    listener: TypedListener<TCEvent>
  ): Promise<this>;

  once<TCEvent extends TypedContractEvent>(
    event: TCEvent,
    listener: TypedListener<TCEvent>
  ): Promise<this>;
  once<TCEvent extends TypedContractEvent>(
    filter: TypedDeferredTopicFilter<TCEvent>,
    listener: TypedListener<TCEvent>
  ): Promise<this>;

  listeners<TCEvent extends TypedContractEvent>(
    event: TCEvent
  ): Promise<Array<TypedListener<TCEvent>>>;
  listeners(eventName?: string): Promise<Array<Listener>>;
  removeAllListeners<TCEvent extends TypedContractEvent>(
    event?: TCEvent
  ): Promise<this>;

  publish: TypedContractMethod<
    [_proof: BytesLike, _batch: BatchStruct],
    [void],
    "nonpayable"
  >;

  getFunction<T extends ContractMethod = ContractMethod>(
    key: string | FunctionFragment
  ): T;

  getFunction(
    nameOrSignature: "publish"
  ): TypedContractMethod<
    [_proof: BytesLike, _batch: BatchStruct],
    [void],
    "nonpayable"
  >;

  filters: {};
}
