/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumberish,
  BytesLike,
  FunctionFragment,
  Result,
  Interface,
  EventFragment,
  AddressLike,
  ContractRunner,
  ContractMethod,
  Listener,
} from "ethers";
import type {
  TypedContractEvent,
  TypedDeferredTopicFilter,
  TypedEventLog,
  TypedLogDescription,
  TypedListener,
  TypedContractMethod,
} from "../../common";

export type EncryptedUTXOStruct = {
  secret: BytesLike;
  amount: BytesLike;
  data: BytesLike;
};

export type EncryptedUTXOStructOutput = [
  secret: string,
  amount: string,
  data: string
] & { secret: string; amount: string; data: string };

export type DepositStruct = { signature: BytesLike; pi_hash: BytesLike };

export type DepositStructOutput = [signature: string, pi_hash: string] & {
  signature: string;
  pi_hash: string;
};

export type TransactionStruct = {
  current_root: BytesLike;
  utxo_root: BytesLike;
  price_limit: BytesLike;
  timestamp: BytesLike;
  deadline: BytesLike;
  amount: BytesLike;
  encrypted_utxo: EncryptedUTXOStruct[];
  withdrawals: BytesLike[];
  commitments_in: BytesLike[];
  commitments: BytesLike[];
  recipients: BytesLike[];
  nullifier_hashes: BytesLike[];
  uids: BytesLike[];
  swap_amounts: BytesLike[];
  deposit: DepositStruct;
};

export type TransactionStructOutput = [
  current_root: string,
  utxo_root: string,
  price_limit: string,
  timestamp: string,
  deadline: string,
  amount: string,
  encrypted_utxo: EncryptedUTXOStructOutput[],
  withdrawals: string[],
  commitments_in: string[],
  commitments: string[],
  recipients: string[],
  nullifier_hashes: string[],
  uids: string[],
  swap_amounts: string[],
  deposit: DepositStructOutput
] & {
  current_root: string;
  utxo_root: string;
  price_limit: string;
  timestamp: string;
  deadline: string;
  amount: string;
  encrypted_utxo: EncryptedUTXOStructOutput[];
  withdrawals: string[];
  commitments_in: string[];
  commitments: string[];
  recipients: string[];
  nullifier_hashes: string[];
  uids: string[];
  swap_amounts: string[];
  deposit: DepositStructOutput;
};

export type TransactionWithProofStruct = {
  transaction: TransactionStruct;
  proof: BytesLike[];
  proofU8: BytesLike;
};

export type TransactionWithProofStructOutput = [
  transaction: TransactionStructOutput,
  proof: string[],
  proofU8: string
] & { transaction: TransactionStructOutput; proof: string[]; proofU8: string };

export type BatchStruct = {
  tx_key_hash: BytesLike;
  recursive_key_hash: BytesLike;
  new_root: BytesLike;
  old_hist_root: BytesLike;
  new_hist_root: BytesLike;
  oracle: BytesLike;
  historic_path: BytesLike[];
  aggregation_object: BytesLike[];
  transactions: TransactionStruct[];
};

export type BatchStructOutput = [
  tx_key_hash: string,
  recursive_key_hash: string,
  new_root: string,
  old_hist_root: string,
  new_hist_root: string,
  oracle: string,
  historic_path: string[],
  aggregation_object: string[],
  transactions: TransactionStructOutput[]
] & {
  tx_key_hash: string;
  recursive_key_hash: string;
  new_root: string;
  old_hist_root: string;
  new_hist_root: string;
  oracle: string;
  historic_path: string[];
  aggregation_object: string[];
  transactions: TransactionStructOutput[];
};

export interface MomijiInterface extends Interface {
  getFunction(
    nameOrSignature:
      | "MAX_ITEMS"
      | "MAX_UTXOS"
      | "STATE_DEPTH"
      | "UPGRADE_INTERFACE_VERSION"
      | "_accumulatePublicInputs"
      | "_getSignatureHash"
      | "batchNumber"
      | "broadcastAddress"
      | "broadcastTransaction"
      | "burnPercentageSwap"
      | "changeBurnPercentage"
      | "changeCap"
      | "changePools"
      | "dailyCap"
      | "dailyMint"
      | "ecRecover"
      | "eip712Domain"
      | "emergencyPause"
      | "emergencyUnpause"
      | "fee"
      | "getSpentNullifiers"
      | "getValidRootAtIndex"
      | "getValidRoots"
      | "getValidRootsPaginated"
      | "hashCircuitInputsForTx"
      | "hashCircuitInputsForTxWithoutDeposit"
      | "hashContractOnlyInputsForTx"
      | "hashContractOnlyInputsForTxWithoutDeposit"
      | "hashTypedDataV4"
      | "histRoot"
      | "initialize"
      | "isSpent"
      | "lastCapReset"
      | "merkleRoot"
      | "nullifierHashes"
      | "oracle"
      | "owner"
      | "paused"
      | "prepareBatchPublicInputs"
      | "proxiableUUID"
      | "publish"
      | "recursiveKeyHash"
      | "relay"
      | "renounceOwnership"
      | "simulatePublish"
      | "swapRouter"
      | "token"
      | "transferOwnership"
      | "txKeyHash"
      | "txWrapperKeyHash"
      | "updateCircuits"
      | "upgradeToAndCall"
      | "utxoPrevRoots"
      | "validRoots"
      | "verifier"
      | "verifyProof"
      | "xft"
      | "xftPool"
  ): FunctionFragment;

  getEvent(
    nameOrSignatureOrTopic:
      | "BatchPublish"
      | "BroadcastAddress"
      | "BurnPercentageChanged"
      | "DailyCapChanged"
      | "EIP712DomainChanged"
      | "EncryptedUTXOBroadcast"
      | "Initialized"
      | "OwnershipTransferred"
      | "Paused"
      | "TransactionBroadcast"
      | "TransactionPublish"
      | "Unpaused"
      | "Upgraded"
  ): EventFragment;

  encodeFunctionData(functionFragment: "MAX_ITEMS", values?: undefined): string;
  encodeFunctionData(functionFragment: "MAX_UTXOS", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "STATE_DEPTH",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "UPGRADE_INTERFACE_VERSION",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "_accumulatePublicInputs",
    values: [BytesLike, BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "_getSignatureHash",
    values: [TransactionStruct]
  ): string;
  encodeFunctionData(
    functionFragment: "batchNumber",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "broadcastAddress",
    values: [string]
  ): string;
  encodeFunctionData(
    functionFragment: "broadcastTransaction",
    values: [TransactionWithProofStruct, BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "burnPercentageSwap",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "changeBurnPercentage",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "changeCap",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "changePools",
    values: [AddressLike[]]
  ): string;
  encodeFunctionData(functionFragment: "dailyCap", values?: undefined): string;
  encodeFunctionData(functionFragment: "dailyMint", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "ecRecover",
    values: [BytesLike, BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "eip712Domain",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "emergencyPause",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "emergencyUnpause",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "fee", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "getSpentNullifiers",
    values: [BytesLike[]]
  ): string;
  encodeFunctionData(
    functionFragment: "getValidRootAtIndex",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "getValidRoots",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getValidRootsPaginated",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "hashCircuitInputsForTx",
    values: [TransactionStruct, BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "hashCircuitInputsForTxWithoutDeposit",
    values: [TransactionStruct]
  ): string;
  encodeFunctionData(
    functionFragment: "hashContractOnlyInputsForTx",
    values: [TransactionStruct, BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "hashContractOnlyInputsForTxWithoutDeposit",
    values: [TransactionStruct]
  ): string;
  encodeFunctionData(
    functionFragment: "hashTypedDataV4",
    values: [DepositStruct]
  ): string;
  encodeFunctionData(functionFragment: "histRoot", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "initialize",
    values: [
      AddressLike,
      AddressLike,
      BytesLike,
      BytesLike,
      BytesLike,
      AddressLike
    ]
  ): string;
  encodeFunctionData(functionFragment: "isSpent", values: [BytesLike]): string;
  encodeFunctionData(
    functionFragment: "lastCapReset",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "merkleRoot",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "nullifierHashes",
    values: [BytesLike]
  ): string;
  encodeFunctionData(functionFragment: "oracle", values?: undefined): string;
  encodeFunctionData(functionFragment: "owner", values?: undefined): string;
  encodeFunctionData(functionFragment: "paused", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "prepareBatchPublicInputs",
    values: [BatchStruct, BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "proxiableUUID",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "publish",
    values: [BytesLike, BatchStruct]
  ): string;
  encodeFunctionData(
    functionFragment: "recursiveKeyHash",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "relay", values: [BytesLike]): string;
  encodeFunctionData(
    functionFragment: "renounceOwnership",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "simulatePublish",
    values: [BatchStruct]
  ): string;
  encodeFunctionData(
    functionFragment: "swapRouter",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "token", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "transferOwnership",
    values: [AddressLike]
  ): string;
  encodeFunctionData(functionFragment: "txKeyHash", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "txWrapperKeyHash",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "updateCircuits",
    values: [BytesLike[]]
  ): string;
  encodeFunctionData(
    functionFragment: "upgradeToAndCall",
    values: [AddressLike, BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "utxoPrevRoots",
    values: [BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "validRoots",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(functionFragment: "verifier", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "verifyProof",
    values: [BytesLike, BatchStruct, BytesLike]
  ): string;
  encodeFunctionData(functionFragment: "xft", values?: undefined): string;
  encodeFunctionData(functionFragment: "xftPool", values?: undefined): string;

  decodeFunctionResult(functionFragment: "MAX_ITEMS", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "MAX_UTXOS", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "STATE_DEPTH",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "UPGRADE_INTERFACE_VERSION",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "_accumulatePublicInputs",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "_getSignatureHash",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "batchNumber",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "broadcastAddress",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "broadcastTransaction",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "burnPercentageSwap",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "changeBurnPercentage",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "changeCap", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "changePools",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "dailyCap", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "dailyMint", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "ecRecover", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "eip712Domain",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "emergencyPause",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "emergencyUnpause",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "fee", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "getSpentNullifiers",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getValidRootAtIndex",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getValidRoots",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getValidRootsPaginated",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "hashCircuitInputsForTx",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "hashCircuitInputsForTxWithoutDeposit",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "hashContractOnlyInputsForTx",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "hashContractOnlyInputsForTxWithoutDeposit",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "hashTypedDataV4",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "histRoot", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "initialize", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "isSpent", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "lastCapReset",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "merkleRoot", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "nullifierHashes",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "oracle", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "paused", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "prepareBatchPublicInputs",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "proxiableUUID",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "publish", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "recursiveKeyHash",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "relay", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "renounceOwnership",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "simulatePublish",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "swapRouter", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "token", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "transferOwnership",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "txKeyHash", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "txWrapperKeyHash",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "updateCircuits",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "upgradeToAndCall",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "utxoPrevRoots",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "validRoots", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "verifier", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "verifyProof",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "xft", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "xftPool", data: BytesLike): Result;
}

export namespace BatchPublishEvent {
  export type InputTuple = [
    _batchNumber: BigNumberish,
    _oldRoot: BytesLike,
    _newRoot: BytesLike,
    _oracle: BytesLike,
    _historicPath: BytesLike[]
  ];
  export type OutputTuple = [
    _batchNumber: bigint,
    _oldRoot: string,
    _newRoot: string,
    _oracle: string,
    _historicPath: string[]
  ];
  export interface OutputObject {
    _batchNumber: bigint;
    _oldRoot: string;
    _newRoot: string;
    _oracle: string;
    _historicPath: string[];
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace BroadcastAddressEvent {
  export type InputTuple = [_merkleRoot: BytesLike, _address: string];
  export type OutputTuple = [_merkleRoot: string, _address: string];
  export interface OutputObject {
    _merkleRoot: string;
    _address: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace BurnPercentageChangedEvent {
  export type InputTuple = [
    _oldPercentage: BigNumberish,
    _newPercentage: BigNumberish
  ];
  export type OutputTuple = [_oldPercentage: bigint, _newPercentage: bigint];
  export interface OutputObject {
    _oldPercentage: bigint;
    _newPercentage: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace DailyCapChangedEvent {
  export type InputTuple = [_oldCap: BigNumberish, _newCap: BigNumberish];
  export type OutputTuple = [_oldCap: bigint, _newCap: bigint];
  export interface OutputObject {
    _oldCap: bigint;
    _newCap: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace EIP712DomainChangedEvent {
  export type InputTuple = [];
  export type OutputTuple = [];
  export interface OutputObject {}
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace EncryptedUTXOBroadcastEvent {
  export type InputTuple = [
    _oldRoot: BytesLike,
    _utxoId: BytesLike,
    _encryptedUTXO: EncryptedUTXOStruct
  ];
  export type OutputTuple = [
    _oldRoot: string,
    _utxoId: string,
    _encryptedUTXO: EncryptedUTXOStructOutput
  ];
  export interface OutputObject {
    _oldRoot: string;
    _utxoId: string;
    _encryptedUTXO: EncryptedUTXOStructOutput;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace InitializedEvent {
  export type InputTuple = [version: BigNumberish];
  export type OutputTuple = [version: bigint];
  export interface OutputObject {
    version: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace OwnershipTransferredEvent {
  export type InputTuple = [previousOwner: AddressLike, newOwner: AddressLike];
  export type OutputTuple = [previousOwner: string, newOwner: string];
  export interface OutputObject {
    previousOwner: string;
    newOwner: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace PausedEvent {
  export type InputTuple = [account: AddressLike];
  export type OutputTuple = [account: string];
  export interface OutputObject {
    account: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace TransactionBroadcastEvent {
  export type InputTuple = [
    _tx: TransactionWithProofStruct,
    _merkleRoot: BytesLike,
    _txId: BytesLike
  ];
  export type OutputTuple = [
    _tx: TransactionWithProofStructOutput,
    _merkleRoot: string,
    _txId: string
  ];
  export interface OutputObject {
    _tx: TransactionWithProofStructOutput;
    _merkleRoot: string;
    _txId: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace TransactionPublishEvent {
  export type InputTuple = [
    _tx: TransactionStruct,
    _merkleRoot: BytesLike,
    _txId: BytesLike
  ];
  export type OutputTuple = [
    _tx: TransactionStructOutput,
    _merkleRoot: string,
    _txId: string
  ];
  export interface OutputObject {
    _tx: TransactionStructOutput;
    _merkleRoot: string;
    _txId: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace UnpausedEvent {
  export type InputTuple = [account: AddressLike];
  export type OutputTuple = [account: string];
  export interface OutputObject {
    account: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace UpgradedEvent {
  export type InputTuple = [implementation: AddressLike];
  export type OutputTuple = [implementation: string];
  export interface OutputObject {
    implementation: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export interface Momiji extends BaseContract {
  connect(runner?: ContractRunner | null): Momiji;
  waitForDeployment(): Promise<this>;

  interface: MomijiInterface;

  queryFilter<TCEvent extends TypedContractEvent>(
    event: TCEvent,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEventLog<TCEvent>>>;
  queryFilter<TCEvent extends TypedContractEvent>(
    filter: TypedDeferredTopicFilter<TCEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEventLog<TCEvent>>>;

  on<TCEvent extends TypedContractEvent>(
    event: TCEvent,
    listener: TypedListener<TCEvent>
  ): Promise<this>;
  on<TCEvent extends TypedContractEvent>(
    filter: TypedDeferredTopicFilter<TCEvent>,
    listener: TypedListener<TCEvent>
  ): Promise<this>;

  once<TCEvent extends TypedContractEvent>(
    event: TCEvent,
    listener: TypedListener<TCEvent>
  ): Promise<this>;
  once<TCEvent extends TypedContractEvent>(
    filter: TypedDeferredTopicFilter<TCEvent>,
    listener: TypedListener<TCEvent>
  ): Promise<this>;

  listeners<TCEvent extends TypedContractEvent>(
    event: TCEvent
  ): Promise<Array<TypedListener<TCEvent>>>;
  listeners(eventName?: string): Promise<Array<Listener>>;
  removeAllListeners<TCEvent extends TypedContractEvent>(
    event?: TCEvent
  ): Promise<this>;

  MAX_ITEMS: TypedContractMethod<[], [bigint], "view">;

  MAX_UTXOS: TypedContractMethod<[], [bigint], "view">;

  STATE_DEPTH: TypedContractMethod<[], [bigint], "view">;

  UPGRADE_INTERFACE_VERSION: TypedContractMethod<[], [string], "view">;

  _accumulatePublicInputs: TypedContractMethod<
    [_previousAccumulator: BytesLike, _publicInputsHash: BytesLike],
    [string],
    "view"
  >;

  _getSignatureHash: TypedContractMethod<
    [_transaction: TransactionStruct],
    [string],
    "view"
  >;

  batchNumber: TypedContractMethod<[], [bigint], "view">;

  broadcastAddress: TypedContractMethod<
    [_address: string],
    [void],
    "nonpayable"
  >;

  broadcastTransaction: TypedContractMethod<
    [_tx: TransactionWithProofStruct, _recipient: BytesLike],
    [void],
    "nonpayable"
  >;

  burnPercentageSwap: TypedContractMethod<[], [bigint], "view">;

  changeBurnPercentage: TypedContractMethod<
    [_percentage: BigNumberish],
    [void],
    "nonpayable"
  >;

  changeCap: TypedContractMethod<[_cap: BigNumberish], [void], "nonpayable">;

  changePools: TypedContractMethod<
    [_addrs: AddressLike[]],
    [void],
    "nonpayable"
  >;

  dailyCap: TypedContractMethod<[], [bigint], "view">;

  dailyMint: TypedContractMethod<[], [bigint], "view">;

  ecRecover: TypedContractMethod<
    [_hash: BytesLike, _signature: BytesLike],
    [string],
    "view"
  >;

  eip712Domain: TypedContractMethod<
    [],
    [
      [string, string, string, bigint, string, string, bigint[]] & {
        fields: string;
        name: string;
        version: string;
        chainId: bigint;
        verifyingContract: string;
        salt: string;
        extensions: bigint[];
      }
    ],
    "view"
  >;

  emergencyPause: TypedContractMethod<[], [void], "nonpayable">;

  emergencyUnpause: TypedContractMethod<[], [void], "nonpayable">;

  fee: TypedContractMethod<[], [bigint], "view">;

  getSpentNullifiers: TypedContractMethod<
    [_nullifierHashes: BytesLike[]],
    [boolean[]],
    "view"
  >;

  getValidRootAtIndex: TypedContractMethod<
    [_index: BigNumberish],
    [string],
    "view"
  >;

  getValidRoots: TypedContractMethod<[], [string[]], "view">;

  getValidRootsPaginated: TypedContractMethod<
    [_start: BigNumberish, _end: BigNumberish],
    [string[]],
    "view"
  >;

  hashCircuitInputsForTx: TypedContractMethod<
    [_tx: TransactionStruct, _signatureHash: BytesLike],
    [string],
    "view"
  >;

  hashCircuitInputsForTxWithoutDeposit: TypedContractMethod<
    [_tx: TransactionStruct],
    [string],
    "view"
  >;

  hashContractOnlyInputsForTx: TypedContractMethod<
    [_tx: TransactionStruct, _signatureHash: BytesLike],
    [string],
    "view"
  >;

  hashContractOnlyInputsForTxWithoutDeposit: TypedContractMethod<
    [_tx: TransactionStruct],
    [string],
    "view"
  >;

  hashTypedDataV4: TypedContractMethod<
    [_deposit: DepositStruct],
    [string],
    "view"
  >;

  histRoot: TypedContractMethod<[], [string], "view">;

  initialize: TypedContractMethod<
    [
      _verifier: AddressLike,
      _token: AddressLike,
      _txKeyHash: BytesLike,
      _txWrapperKeyHash: BytesLike,
      _recursiveKeyHash: BytesLike,
      _xftPool: AddressLike
    ],
    [void],
    "nonpayable"
  >;

  isSpent: TypedContractMethod<[_nullifierHash: BytesLike], [boolean], "view">;

  lastCapReset: TypedContractMethod<[], [bigint], "view">;

  merkleRoot: TypedContractMethod<[], [string], "view">;

  nullifierHashes: TypedContractMethod<[arg0: BytesLike], [boolean], "view">;

  oracle: TypedContractMethod<[], [string], "view">;

  owner: TypedContractMethod<[], [string], "view">;

  paused: TypedContractMethod<[], [boolean], "view">;

  prepareBatchPublicInputs: TypedContractMethod<
    [_batch: BatchStruct, _accumulator: BytesLike],
    [string],
    "view"
  >;

  proxiableUUID: TypedContractMethod<[], [string], "view">;

  publish: TypedContractMethod<
    [_proof: BytesLike, _batch: BatchStruct],
    [void],
    "nonpayable"
  >;

  recursiveKeyHash: TypedContractMethod<[], [string], "view">;

  relay: TypedContractMethod<[arg0: BytesLike], [string], "view">;

  renounceOwnership: TypedContractMethod<[], [void], "nonpayable">;

  simulatePublish: TypedContractMethod<
    [_batch: BatchStruct],
    [void],
    "nonpayable"
  >;

  swapRouter: TypedContractMethod<[], [string], "view">;

  token: TypedContractMethod<[], [string], "view">;

  transferOwnership: TypedContractMethod<
    [newOwner: AddressLike],
    [void],
    "nonpayable"
  >;

  txKeyHash: TypedContractMethod<[], [string], "view">;

  txWrapperKeyHash: TypedContractMethod<[], [string], "view">;

  updateCircuits: TypedContractMethod<
    [_circuits: BytesLike[]],
    [void],
    "nonpayable"
  >;

  upgradeToAndCall: TypedContractMethod<
    [newImplementation: AddressLike, data: BytesLike],
    [void],
    "payable"
  >;

  utxoPrevRoots: TypedContractMethod<[arg0: BytesLike], [string], "view">;

  validRoots: TypedContractMethod<[arg0: BigNumberish], [string], "view">;

  verifier: TypedContractMethod<[], [string], "view">;

  verifyProof: TypedContractMethod<
    [_proof: BytesLike, _batch: BatchStruct, _accumulator: BytesLike],
    [boolean],
    "view"
  >;

  xft: TypedContractMethod<[], [string], "view">;

  xftPool: TypedContractMethod<[], [string], "view">;

  getFunction<T extends ContractMethod = ContractMethod>(
    key: string | FunctionFragment
  ): T;

  getFunction(
    nameOrSignature: "MAX_ITEMS"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "MAX_UTXOS"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "STATE_DEPTH"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "UPGRADE_INTERFACE_VERSION"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "_accumulatePublicInputs"
  ): TypedContractMethod<
    [_previousAccumulator: BytesLike, _publicInputsHash: BytesLike],
    [string],
    "view"
  >;
  getFunction(
    nameOrSignature: "_getSignatureHash"
  ): TypedContractMethod<[_transaction: TransactionStruct], [string], "view">;
  getFunction(
    nameOrSignature: "batchNumber"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "broadcastAddress"
  ): TypedContractMethod<[_address: string], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "broadcastTransaction"
  ): TypedContractMethod<
    [_tx: TransactionWithProofStruct, _recipient: BytesLike],
    [void],
    "nonpayable"
  >;
  getFunction(
    nameOrSignature: "burnPercentageSwap"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "changeBurnPercentage"
  ): TypedContractMethod<[_percentage: BigNumberish], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "changeCap"
  ): TypedContractMethod<[_cap: BigNumberish], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "changePools"
  ): TypedContractMethod<[_addrs: AddressLike[]], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "dailyCap"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "dailyMint"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "ecRecover"
  ): TypedContractMethod<
    [_hash: BytesLike, _signature: BytesLike],
    [string],
    "view"
  >;
  getFunction(
    nameOrSignature: "eip712Domain"
  ): TypedContractMethod<
    [],
    [
      [string, string, string, bigint, string, string, bigint[]] & {
        fields: string;
        name: string;
        version: string;
        chainId: bigint;
        verifyingContract: string;
        salt: string;
        extensions: bigint[];
      }
    ],
    "view"
  >;
  getFunction(
    nameOrSignature: "emergencyPause"
  ): TypedContractMethod<[], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "emergencyUnpause"
  ): TypedContractMethod<[], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "fee"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "getSpentNullifiers"
  ): TypedContractMethod<[_nullifierHashes: BytesLike[]], [boolean[]], "view">;
  getFunction(
    nameOrSignature: "getValidRootAtIndex"
  ): TypedContractMethod<[_index: BigNumberish], [string], "view">;
  getFunction(
    nameOrSignature: "getValidRoots"
  ): TypedContractMethod<[], [string[]], "view">;
  getFunction(
    nameOrSignature: "getValidRootsPaginated"
  ): TypedContractMethod<
    [_start: BigNumberish, _end: BigNumberish],
    [string[]],
    "view"
  >;
  getFunction(
    nameOrSignature: "hashCircuitInputsForTx"
  ): TypedContractMethod<
    [_tx: TransactionStruct, _signatureHash: BytesLike],
    [string],
    "view"
  >;
  getFunction(
    nameOrSignature: "hashCircuitInputsForTxWithoutDeposit"
  ): TypedContractMethod<[_tx: TransactionStruct], [string], "view">;
  getFunction(
    nameOrSignature: "hashContractOnlyInputsForTx"
  ): TypedContractMethod<
    [_tx: TransactionStruct, _signatureHash: BytesLike],
    [string],
    "view"
  >;
  getFunction(
    nameOrSignature: "hashContractOnlyInputsForTxWithoutDeposit"
  ): TypedContractMethod<[_tx: TransactionStruct], [string], "view">;
  getFunction(
    nameOrSignature: "hashTypedDataV4"
  ): TypedContractMethod<[_deposit: DepositStruct], [string], "view">;
  getFunction(
    nameOrSignature: "histRoot"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "initialize"
  ): TypedContractMethod<
    [
      _verifier: AddressLike,
      _token: AddressLike,
      _txKeyHash: BytesLike,
      _txWrapperKeyHash: BytesLike,
      _recursiveKeyHash: BytesLike,
      _xftPool: AddressLike
    ],
    [void],
    "nonpayable"
  >;
  getFunction(
    nameOrSignature: "isSpent"
  ): TypedContractMethod<[_nullifierHash: BytesLike], [boolean], "view">;
  getFunction(
    nameOrSignature: "lastCapReset"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "merkleRoot"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "nullifierHashes"
  ): TypedContractMethod<[arg0: BytesLike], [boolean], "view">;
  getFunction(
    nameOrSignature: "oracle"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "owner"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "paused"
  ): TypedContractMethod<[], [boolean], "view">;
  getFunction(
    nameOrSignature: "prepareBatchPublicInputs"
  ): TypedContractMethod<
    [_batch: BatchStruct, _accumulator: BytesLike],
    [string],
    "view"
  >;
  getFunction(
    nameOrSignature: "proxiableUUID"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "publish"
  ): TypedContractMethod<
    [_proof: BytesLike, _batch: BatchStruct],
    [void],
    "nonpayable"
  >;
  getFunction(
    nameOrSignature: "recursiveKeyHash"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "relay"
  ): TypedContractMethod<[arg0: BytesLike], [string], "view">;
  getFunction(
    nameOrSignature: "renounceOwnership"
  ): TypedContractMethod<[], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "simulatePublish"
  ): TypedContractMethod<[_batch: BatchStruct], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "swapRouter"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "token"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "transferOwnership"
  ): TypedContractMethod<[newOwner: AddressLike], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "txKeyHash"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "txWrapperKeyHash"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "updateCircuits"
  ): TypedContractMethod<[_circuits: BytesLike[]], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "upgradeToAndCall"
  ): TypedContractMethod<
    [newImplementation: AddressLike, data: BytesLike],
    [void],
    "payable"
  >;
  getFunction(
    nameOrSignature: "utxoPrevRoots"
  ): TypedContractMethod<[arg0: BytesLike], [string], "view">;
  getFunction(
    nameOrSignature: "validRoots"
  ): TypedContractMethod<[arg0: BigNumberish], [string], "view">;
  getFunction(
    nameOrSignature: "verifier"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "verifyProof"
  ): TypedContractMethod<
    [_proof: BytesLike, _batch: BatchStruct, _accumulator: BytesLike],
    [boolean],
    "view"
  >;
  getFunction(
    nameOrSignature: "xft"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "xftPool"
  ): TypedContractMethod<[], [string], "view">;

  getEvent(
    key: "BatchPublish"
  ): TypedContractEvent<
    BatchPublishEvent.InputTuple,
    BatchPublishEvent.OutputTuple,
    BatchPublishEvent.OutputObject
  >;
  getEvent(
    key: "BroadcastAddress"
  ): TypedContractEvent<
    BroadcastAddressEvent.InputTuple,
    BroadcastAddressEvent.OutputTuple,
    BroadcastAddressEvent.OutputObject
  >;
  getEvent(
    key: "BurnPercentageChanged"
  ): TypedContractEvent<
    BurnPercentageChangedEvent.InputTuple,
    BurnPercentageChangedEvent.OutputTuple,
    BurnPercentageChangedEvent.OutputObject
  >;
  getEvent(
    key: "DailyCapChanged"
  ): TypedContractEvent<
    DailyCapChangedEvent.InputTuple,
    DailyCapChangedEvent.OutputTuple,
    DailyCapChangedEvent.OutputObject
  >;
  getEvent(
    key: "EIP712DomainChanged"
  ): TypedContractEvent<
    EIP712DomainChangedEvent.InputTuple,
    EIP712DomainChangedEvent.OutputTuple,
    EIP712DomainChangedEvent.OutputObject
  >;
  getEvent(
    key: "EncryptedUTXOBroadcast"
  ): TypedContractEvent<
    EncryptedUTXOBroadcastEvent.InputTuple,
    EncryptedUTXOBroadcastEvent.OutputTuple,
    EncryptedUTXOBroadcastEvent.OutputObject
  >;
  getEvent(
    key: "Initialized"
  ): TypedContractEvent<
    InitializedEvent.InputTuple,
    InitializedEvent.OutputTuple,
    InitializedEvent.OutputObject
  >;
  getEvent(
    key: "OwnershipTransferred"
  ): TypedContractEvent<
    OwnershipTransferredEvent.InputTuple,
    OwnershipTransferredEvent.OutputTuple,
    OwnershipTransferredEvent.OutputObject
  >;
  getEvent(
    key: "Paused"
  ): TypedContractEvent<
    PausedEvent.InputTuple,
    PausedEvent.OutputTuple,
    PausedEvent.OutputObject
  >;
  getEvent(
    key: "TransactionBroadcast"
  ): TypedContractEvent<
    TransactionBroadcastEvent.InputTuple,
    TransactionBroadcastEvent.OutputTuple,
    TransactionBroadcastEvent.OutputObject
  >;
  getEvent(
    key: "TransactionPublish"
  ): TypedContractEvent<
    TransactionPublishEvent.InputTuple,
    TransactionPublishEvent.OutputTuple,
    TransactionPublishEvent.OutputObject
  >;
  getEvent(
    key: "Unpaused"
  ): TypedContractEvent<
    UnpausedEvent.InputTuple,
    UnpausedEvent.OutputTuple,
    UnpausedEvent.OutputObject
  >;
  getEvent(
    key: "Upgraded"
  ): TypedContractEvent<
    UpgradedEvent.InputTuple,
    UpgradedEvent.OutputTuple,
    UpgradedEvent.OutputObject
  >;

  filters: {
    "BatchPublish(uint256,bytes32,bytes32,bytes32,bytes32[20])": TypedContractEvent<
      BatchPublishEvent.InputTuple,
      BatchPublishEvent.OutputTuple,
      BatchPublishEvent.OutputObject
    >;
    BatchPublish: TypedContractEvent<
      BatchPublishEvent.InputTuple,
      BatchPublishEvent.OutputTuple,
      BatchPublishEvent.OutputObject
    >;

    "BroadcastAddress(bytes32,string)": TypedContractEvent<
      BroadcastAddressEvent.InputTuple,
      BroadcastAddressEvent.OutputTuple,
      BroadcastAddressEvent.OutputObject
    >;
    BroadcastAddress: TypedContractEvent<
      BroadcastAddressEvent.InputTuple,
      BroadcastAddressEvent.OutputTuple,
      BroadcastAddressEvent.OutputObject
    >;

    "BurnPercentageChanged(uint256,uint256)": TypedContractEvent<
      BurnPercentageChangedEvent.InputTuple,
      BurnPercentageChangedEvent.OutputTuple,
      BurnPercentageChangedEvent.OutputObject
    >;
    BurnPercentageChanged: TypedContractEvent<
      BurnPercentageChangedEvent.InputTuple,
      BurnPercentageChangedEvent.OutputTuple,
      BurnPercentageChangedEvent.OutputObject
    >;

    "DailyCapChanged(uint256,uint256)": TypedContractEvent<
      DailyCapChangedEvent.InputTuple,
      DailyCapChangedEvent.OutputTuple,
      DailyCapChangedEvent.OutputObject
    >;
    DailyCapChanged: TypedContractEvent<
      DailyCapChangedEvent.InputTuple,
      DailyCapChangedEvent.OutputTuple,
      DailyCapChangedEvent.OutputObject
    >;

    "EIP712DomainChanged()": TypedContractEvent<
      EIP712DomainChangedEvent.InputTuple,
      EIP712DomainChangedEvent.OutputTuple,
      EIP712DomainChangedEvent.OutputObject
    >;
    EIP712DomainChanged: TypedContractEvent<
      EIP712DomainChangedEvent.InputTuple,
      EIP712DomainChangedEvent.OutputTuple,
      EIP712DomainChangedEvent.OutputObject
    >;

    "EncryptedUTXOBroadcast(bytes32,bytes32,tuple)": TypedContractEvent<
      EncryptedUTXOBroadcastEvent.InputTuple,
      EncryptedUTXOBroadcastEvent.OutputTuple,
      EncryptedUTXOBroadcastEvent.OutputObject
    >;
    EncryptedUTXOBroadcast: TypedContractEvent<
      EncryptedUTXOBroadcastEvent.InputTuple,
      EncryptedUTXOBroadcastEvent.OutputTuple,
      EncryptedUTXOBroadcastEvent.OutputObject
    >;

    "Initialized(uint64)": TypedContractEvent<
      InitializedEvent.InputTuple,
      InitializedEvent.OutputTuple,
      InitializedEvent.OutputObject
    >;
    Initialized: TypedContractEvent<
      InitializedEvent.InputTuple,
      InitializedEvent.OutputTuple,
      InitializedEvent.OutputObject
    >;

    "OwnershipTransferred(address,address)": TypedContractEvent<
      OwnershipTransferredEvent.InputTuple,
      OwnershipTransferredEvent.OutputTuple,
      OwnershipTransferredEvent.OutputObject
    >;
    OwnershipTransferred: TypedContractEvent<
      OwnershipTransferredEvent.InputTuple,
      OwnershipTransferredEvent.OutputTuple,
      OwnershipTransferredEvent.OutputObject
    >;

    "Paused(address)": TypedContractEvent<
      PausedEvent.InputTuple,
      PausedEvent.OutputTuple,
      PausedEvent.OutputObject
    >;
    Paused: TypedContractEvent<
      PausedEvent.InputTuple,
      PausedEvent.OutputTuple,
      PausedEvent.OutputObject
    >;

    "TransactionBroadcast(tuple,bytes32,bytes32)": TypedContractEvent<
      TransactionBroadcastEvent.InputTuple,
      TransactionBroadcastEvent.OutputTuple,
      TransactionBroadcastEvent.OutputObject
    >;
    TransactionBroadcast: TypedContractEvent<
      TransactionBroadcastEvent.InputTuple,
      TransactionBroadcastEvent.OutputTuple,
      TransactionBroadcastEvent.OutputObject
    >;

    "TransactionPublish(tuple,bytes32,bytes32)": TypedContractEvent<
      TransactionPublishEvent.InputTuple,
      TransactionPublishEvent.OutputTuple,
      TransactionPublishEvent.OutputObject
    >;
    TransactionPublish: TypedContractEvent<
      TransactionPublishEvent.InputTuple,
      TransactionPublishEvent.OutputTuple,
      TransactionPublishEvent.OutputObject
    >;

    "Unpaused(address)": TypedContractEvent<
      UnpausedEvent.InputTuple,
      UnpausedEvent.OutputTuple,
      UnpausedEvent.OutputObject
    >;
    Unpaused: TypedContractEvent<
      UnpausedEvent.InputTuple,
      UnpausedEvent.OutputTuple,
      UnpausedEvent.OutputObject
    >;

    "Upgraded(address)": TypedContractEvent<
      UpgradedEvent.InputTuple,
      UpgradedEvent.OutputTuple,
      UpgradedEvent.OutputObject
    >;
    Upgraded: TypedContractEvent<
      UpgradedEvent.InputTuple,
      UpgradedEvent.OutputTuple,
      UpgradedEvent.OutputObject
    >;
  };
}
